/*****************************************************************************
 * pce                                                                       *
 *****************************************************************************/

/*****************************************************************************
 * File name:     contrib/mkhdimage/mkhdimage.c                              *
 * Created:       2003-04-19 by Hampa Hug <hampa@hampa.ch>                   *
 * Last modified: 2004-02-22 by Hampa Hug <hampa@hampa.ch>                   *
 * Copyright:     (C) 1999-2004 Hampa Hug <hampa@hampa.ch>                   *
 *****************************************************************************/

/*****************************************************************************
 * This program is free software. You can redistribute it and / or modify it *
 * under the terms of the GNU General Public License version 2 as  published *
 * by the Free Software Foundation.                                          *
 *                                                                           *
 * This program is distributed in the hope  that  it  will  be  useful,  but *
 * WITHOUT  ANY   WARRANTY,   without   even   the   implied   warranty   of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  General *
 * Public License for more details.                                          *
 *****************************************************************************/

/* $Id$ */


/*****************************************************************************
DOSEMU image file format:

offset size description
0      7    magic ("DOSEMU\0")
7      4    number of heads
11     4    sectors per track
15     4    number of tracks
19     4    file pointer to image start

- numbers are little endian
- the image seems to start at 128 for all existing files
******************************************************************************/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>


int main (int argc, char **argv)
{
  unsigned long c, h, s, n;
  unsigned char buf[4096];

  if (argc != 4) {
    fprintf (stderr, "usage: %s cylinders heads sectors\n", argv[0]);
    return (1);
  }

  c = strtoul (argv[1], NULL, 0);
  h = strtoul (argv[2], NULL, 0);
  s = strtoul (argv[3], NULL, 0);

  memset (buf, 0, 128);

  memcpy (buf, "DOSEMU\x00", 7);

  buf[7] = h & 0xff;
  buf[8] = (h >> 8) & 0xff;
  buf[9] = (h >> 16) & 0xff;
  buf[10] = (h >> 24) & 0xff;

  buf[11] = s & 0xff;
  buf[12] = (s >> 8) & 0xff;
  buf[13] = (s >> 16) & 0xff;
  buf[14] = (s >> 24) & 0xff;

  buf[15] = c & 0xff;
  buf[16] = (c >> 8) & 0xff;
  buf[17] = (c >> 16) & 0xff;
  buf[18] = (c >> 24) & 0xff;

  buf[19] = 128;
  buf[20] = 0;
  buf[21] = 0;
  buf[22] = 0;

  fwrite (buf, 1, 128, stdout);

  memset (buf, 0, 512);

  n = c * h * s;
  while (n > 0) {
    fwrite (buf, 1, 512, stdout);
    n -= 1;
  }

  return (0);
}
